import gym
from gym.spaces.utils import flatdim


class Environment:
    state = None

    def __init__(self, gym_env_name):
        self.gym_env = gym.make(gym_env_name)

    def reset(self):
        self.state = self.gym_env.reset()

    def get_available_actions(self):
        num_actions = flatdim(self.gym_env.action_space)
        # num_actions = self.gym_env.action_space.n
        available_actions = list(range(num_actions))
        return available_actions

    def observe(self, observation_wrapper):
        available_actions = self.get_available_actions()
        return observation_wrapper(self.state, available_actions)

    def step(self, action, reward_wrapper):
        self.state, reward, done, info = self.gym_env.step(action)
        return reward_wrapper(reward), done
