from collections import defaultdict, Counter


class Quality:
    model = None
    observation_action_visit_count = defaultdict(lambda: Counter())
    observation_action_returns_sum = defaultdict(lambda: defaultdict(float))
    observation_action_value = defaultdict(lambda: defaultdict(float))

    def predict_action_value(self, observation, action):
        # return self.model.predict(observation, action)
        return self.observation_action_value[observation][action]

    def learn(self, trajectories, gamma, alpha):
        for trajectory in trajectories:
            for i, (observation, action, reward) in enumerate(trajectory):
                sum_of_discounted_rewards = sum(
                    [
                        gamma ** (j - i) * trajectory[j][-1]
                        for j in range(i, len(trajectory))
                    ]
                )

                self.observation_action_visit_count[observation][action] += 1
                self.observation_action_returns_sum[observation][
                    action
                ] += sum_of_discounted_rewards
                self.observation_action_value[observation][action] = (
                    self.observation_action_returns_sum[observation][action]
                    / self.observation_action_visit_count[observation][action]
                )
